<?php

namespace Database\Factories;

use App\enum\UserLevel;
use App\Models\User;
use Illuminate\Database\Eloquent\Factories\Factory;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;

/**
 * @extends Factory<User>
 */
class UserFactory extends Factory
{
    /**
     * The current password being used by the factory.
     */
    protected static ?string $password;

    /**
     * Define the model's default state.
     *
     * @return array<string, mixed>
     */
    public function definition(): array
    {
        return [
            'name' => fake()->name(),
            'email' => fake()->unique()->safeEmail(),
            'email_verified_at' => now(),
            'password' => static::$password ??= Hash::make('password'),
            'remember_token' => Str::random(10),
            'level' => UserLevel::NORMALUSER->value,
        ];
    }

    /**
     * Indicate that the model's email address should be unverified.
     */
    public function unverified(): static
    {
        return $this->state(fn (array $attributes): array => [
            'email_verified_at' => null,
        ]);
    }

    /**
     * Create a super admin user.
     */
    public function superAdmin(): static
    {
        return $this->state(fn (array $attributes): array => [
            'level' => UserLevel::SUPERADMIN->value,
            'email' => fake()->unique()->safeEmail(),
        ]);
    }

    /**
     * Create a normal user.
     */
    public function normalUser(): static
    {
        return $this->state(fn (array $attributes): array => [
            'level' => UserLevel::NORMALUSER->value,
        ]);
    }

    /**
     * Create a banned user.
     */
    public function bannedUser(): static
    {
        return $this->state(fn (array $attributes): array => [
            'level' => UserLevel::BANNEDUSER->value,
        ]);
    }
}
